/**************************************************************************************************
  ADC_DAC.h
  Driver for the Analog to Digital Converter and the Digital to Analog Converter.
**************************************************************************************************/
#ifndef ADCDAC_H
#define ADCDAC_H


// Defines
#define TSEL1_Bit0 0x00000008
#define TSEL1_Bit1 0x00000010
#define TSEL1_Bit2 0x00200020

#define TSEL2_Bit0 0x00080000
#define TSEL2_Bit1 0x00100000
#define TSEL2_Bit2 0x00200000

// Function Prototypes
void EnableDAC1(void);
void EnableDAC2(void);
void EnableDACs(void);
void SetDAC1(unsigned long Data);
void SetDAC2(unsigned long Data);
void SetDACs(unsigned long Data1, unsigned long Data2);
void SetDAC_Ch1(unsigned long Data);


void DAC1_Initialize(void);
void DAC1_Set(unsigned Value);
void DAC2_Initialize(void);
void DAC2_Set(unsigned Value);
void DoSine(void);



void DispDAC_CR(void);

void DispDAC_DHR12R1(void);
void DispDAC_DOR1(void);

void DispDAC_DHR12R2(void);
void DispDAC_DOR2(void);



#endif