/**************************************************************************************************
   Main.c - Test program

   Date: January 1, 2014

   Configuration:
       MCU:                STM32F415RG
       Development Board:  Mini-M4 for STM32
       Crystal Oscillator: 16 MHz
       System Clock:       120 MHz
       Compiler:           mikroC PRO for ARM
       Program Loader:     USB_HID Bootloader
       Power:              USB cable
*/


#include "USB_Driver.h"
#include "LED.h"
#include "RTC.h"
#include "Timers.h"
#include "ADC_DAC.h"



void main() {
     USB_Init();                   // Intitialize USB
     LED_Initialize();             // Intitialize LEDs
     RTC_Initialize();             // Initialize the Real Time Clock
     TimerInit();                  // Initialize timer
     
     EnableInterrupts();           // Enable interrupts
     
     while(1) {
          USB_CheckIn();           // Check for incoming USB messages
          USB_CheckOut();          // Check for outgoing USB messages
          TimerCheck();            // Check timer one second event
     }
     
}