_RTC_Initialize:
;RTC.c,23 :: 		void RTC_Initialize(void) {
;RTC.c,25 :: 		RCC_APB1ENR.PWREN = 1;            // Enable power interface clock
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(RCC_APB1ENR+0)
MOVT	R0, #hi_addr(RCC_APB1ENR+0)
STR	R1, [R0, #0]
;RTC.c,27 :: 		if (RCC_BDCR.RTCEN == 0) {        // if RTC is disabled ...
MOVW	R1, #lo_addr(RCC_BDCR+0)
MOVT	R1, #hi_addr(RCC_BDCR+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	NE
BNE	L_RTC_Initialize0
;RTC.c,28 :: 		PWR_CR.DBP = 1;               // Allow access to RTC
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(PWR_CR+0)
MOVT	R0, #hi_addr(PWR_CR+0)
STR	R1, [R0, #0]
;RTC.c,29 :: 		RTC_WPR = 0xCA;               // Unlock write protection
MOVS	R1, #202
MOVW	R0, #lo_addr(RTC_WPR+0)
MOVT	R0, #hi_addr(RTC_WPR+0)
STR	R1, [R0, #0]
;RTC.c,30 :: 		RTC_WPR = 0x53;               // Unlock write protection
MOVS	R1, #83
MOVW	R0, #lo_addr(RTC_WPR+0)
MOVT	R0, #hi_addr(RTC_WPR+0)
STR	R1, [R0, #0]
;RTC.c,32 :: 		RCC_BDCR = 0x00010000;        // Make it possible to change clock source
MOV	R1, #65536
MOVW	R0, #lo_addr(RCC_BDCR+0)
MOVT	R0, #hi_addr(RCC_BDCR+0)
STR	R1, [R0, #0]
;RTC.c,33 :: 		RCC_BDCR = 0x00008101;        // Set RTCEN, LSE, LSEON
MOVW	R1, #33025
MOVW	R0, #lo_addr(RCC_BDCR+0)
MOVT	R0, #hi_addr(RCC_BDCR+0)
STR	R1, [R0, #0]
;RTC.c,34 :: 		}
L_RTC_Initialize0:
;RTC.c,37 :: 		while(RTC_ISR.RSF != 1) {}        // Wait for RTC APB registers synchronisation
L_RTC_Initialize1:
MOVW	R1, #lo_addr(RTC_ISR+0)
MOVT	R1, #hi_addr(RTC_ISR+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	NE
BNE	L_RTC_Initialize2
IT	AL
BAL	L_RTC_Initialize1
L_RTC_Initialize2:
;RTC.c,41 :: 		while(RCC_BDCR.LSERDY != 1) {};   // Wait till LSE is ready
L_RTC_Initialize3:
MOVW	R1, #lo_addr(RCC_BDCR+0)
MOVT	R1, #hi_addr(RCC_BDCR+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	NE
BNE	L_RTC_Initialize4
IT	AL
BAL	L_RTC_Initialize3
L_RTC_Initialize4:
;RTC.c,44 :: 		RTC_WPR = 0xFF;                   // Set write protection register lock
MOVS	R1, #255
MOVW	R0, #lo_addr(RTC_WPR+0)
MOVT	R0, #hi_addr(RTC_WPR+0)
STR	R1, [R0, #0]
;RTC.c,45 :: 		}
L_end_RTC_Initialize:
BX	LR
; end of _RTC_Initialize
_RTC_Write:
;RTC.c,49 :: 		void RTC_Write(TTime *RTCC_Time) {
; RTCC_Time start address is: 0 (R0)
SUB	SP, SP, #16
STR	LR, [SP, #0]
; RTCC_Time end address is: 0 (R0)
; RTCC_Time start address is: 0 (R0)
;RTC.c,53 :: 		PWR_CR.DBP = 1;                   // Enable access to RTC, RTC backup regs, SRAM
MOVS	R2, #1
SXTB	R2, R2
MOVW	R1, #lo_addr(PWR_CR+0)
MOVT	R1, #hi_addr(PWR_CR+0)
STR	R2, [R1, #0]
;RTC.c,54 :: 		RTC_WPR = 0xCA;                   // Unlock write protection
MOVS	R2, #202
MOVW	R1, #lo_addr(RTC_WPR+0)
MOVT	R1, #hi_addr(RTC_WPR+0)
STR	R2, [R1, #0]
;RTC.c,55 :: 		RTC_WPR = 0x53;                   // Unlock write protection
MOVS	R2, #83
MOVW	R1, #lo_addr(RTC_WPR+0)
MOVT	R1, #hi_addr(RTC_WPR+0)
STR	R2, [R1, #0]
;RTC.c,57 :: 		RTC_ISR = 0x00000080;             // Set initialization mode (bit 7 of RTC_ISR)
MOVS	R2, #128
MOVW	R1, #lo_addr(RTC_ISR+0)
MOVT	R1, #hi_addr(RTC_ISR+0)
STR	R2, [R1, #0]
; RTCC_Time end address is: 0 (R0)
MOV	R4, R0
;RTC.c,60 :: 		while(RTC_ISR.INITF != 1) {};     // Wait for INITF (bit 6 of RTC_ISR) to come on
L_RTC_Write5:
; RTCC_Time start address is: 16 (R4)
MOVW	R2, #lo_addr(RTC_ISR+0)
MOVT	R2, #hi_addr(RTC_ISR+0)
LDR	R1, [R2, #0]
CMP	R1, #0
IT	NE
BNE	L_RTC_Write6
IT	AL
BAL	L_RTC_Write5
L_RTC_Write6:
;RTC.c,63 :: 		RTC_PRERBITS.PREDIV_S = 0xFF;     // Set synchronous prescaler factor to 256
MOVS	R3, #255
MOVW	R2, #lo_addr(RTC_PRERbits+0)
MOVT	R2, #hi_addr(RTC_PRERbits+0)
LDRH	R1, [R2, #0]
BFI	R1, R3, #0, #15
STRH	R1, [R2, #0]
;RTC.c,64 :: 		RTC_PRERBITS.PREDIV_A = 0x7F;     // Set asynchronous division factor to 128
MOVS	R3, #127
MOVW	R2, #lo_addr(RTC_PRERbits+0)
MOVT	R2, #hi_addr(RTC_PRERbits+0)
LDR	R1, [R2, #0]
BFI	R1, R3, #16, #7
STR	R1, [R2, #0]
;RTC.c,69 :: 		temp = (unsigned long)Dec2BCD16(RTCC_Time->year) << 16;
LDRH	R1, [R4, #0]
UXTH	R0, R1
BL	_Dec2Bcd16+0
UXTH	R5, R0
LSLS	R5, R5, #16
;RTC.c,70 :: 		temp |= (unsigned long)RTCC_Time->weekday << 13;
ADDS	R1, R4, #2
LDRB	R1, [R1, #0]
LSLS	R1, R1, #13
ORRS	R5, R1
; temp start address is: 20 (R5)
;RTC.c,71 :: 		temp |= (unsigned long)Dec2BCD(RTCC_Time->month) << 8;
ADDS	R1, R4, #3
LDRB	R1, [R1, #0]
UXTB	R0, R1
BL	_Dec2Bcd+0
UXTB	R1, R0
LSLS	R1, R1, #8
ORRS	R5, R1
;RTC.c,72 :: 		temp |= (unsigned long)Dec2Bcd(RTCC_Time->day);
ADDS	R1, R4, #4
LDRB	R1, [R1, #0]
UXTB	R0, R1
BL	_Dec2Bcd+0
UXTB	R1, R0
ORRS	R5, R1
;RTC.c,75 :: 		BufNum = GetBuffer();
STR	R5, [SP, #4]
STR	R4, [SP, #8]
BL	_GetBuffer+0
LDR	R4, [SP, #8]
LDR	R5, [SP, #4]
; BufNum start address is: 24 (R6)
MOV	R6, R0
;RTC.c,76 :: 		sprintf(BufNum,"%08LX\r\n",temp); // Display assembled long word
MOV	R3, R5
MOVW	R2, #lo_addr(?lstr_1_RTC+0)
MOVT	R2, #hi_addr(?lstr_1_RTC+0)
MOV	R1, R0
STR	R6, [SP, #4]
STR	R5, [SP, #8]
STR	R4, [SP, #12]
PUSH	(R3)
PUSH	(R2)
PUSH	(R1)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R4, [SP, #12]
LDR	R5, [SP, #8]
LDR	R6, [SP, #4]
;RTC.c,77 :: 		USB_PutQueue(BufNum);
STR	R5, [SP, #4]
; BufNum end address is: 24 (R6)
STR	R4, [SP, #8]
MOV	R0, R6
BL	_USB_PutQueue+0
LDR	R4, [SP, #8]
LDR	R5, [SP, #4]
;RTC.c,79 :: 		RTC_DR = temp;                    // Set date register in RTC
MOVW	R1, #lo_addr(RTC_DR+0)
MOVT	R1, #hi_addr(RTC_DR+0)
STR	R5, [R1, #0]
; temp end address is: 20 (R5)
;RTC.c,83 :: 		temp = (unsigned long)Dec2Bcd(RTCC_Time->hours) << 16;
ADDS	R1, R4, #5
LDRB	R1, [R1, #0]
UXTB	R0, R1
BL	_Dec2Bcd+0
UXTB	R5, R0
LSLS	R5, R5, #16
; temp start address is: 20 (R5)
;RTC.c,84 :: 		temp |= (unsigned long)Dec2BCD(RTCC_Time->minutes) << 8;
ADDS	R1, R4, #6
LDRB	R1, [R1, #0]
UXTB	R0, R1
BL	_Dec2Bcd+0
UXTB	R1, R0
LSLS	R1, R1, #8
ORRS	R5, R1
;RTC.c,85 :: 		temp |= (unsigned long)Dec2BCD(RTCC_Time->seconds);
ADDS	R1, R4, #7
; RTCC_Time end address is: 16 (R4)
LDRB	R1, [R1, #0]
UXTB	R0, R1
BL	_Dec2Bcd+0
UXTB	R1, R0
ORR	R1, R5, R1, LSL #0
; temp end address is: 20 (R5)
; temp start address is: 16 (R4)
MOV	R4, R1
;RTC.c,88 :: 		BufNum = GetBuffer();
STR	R4, [SP, #4]
BL	_GetBuffer+0
LDR	R4, [SP, #4]
; BufNum start address is: 20 (R5)
MOV	R5, R0
;RTC.c,89 :: 		sprintf(BufNum,"%08LX\r\n",temp); // Display assembled long word
MOV	R3, R4
MOVW	R2, #lo_addr(?lstr_2_RTC+0)
MOVT	R2, #hi_addr(?lstr_2_RTC+0)
MOV	R1, R0
STR	R5, [SP, #4]
STR	R4, [SP, #8]
PUSH	(R3)
PUSH	(R2)
PUSH	(R1)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R4, [SP, #8]
LDR	R5, [SP, #4]
;RTC.c,90 :: 		USB_PutQueue(BufNum);
STR	R4, [SP, #4]
; BufNum end address is: 20 (R5)
MOV	R0, R5
BL	_USB_PutQueue+0
LDR	R4, [SP, #4]
;RTC.c,92 :: 		RTC_TR = temp;                    // Set Time register in RTC
MOVW	R1, #lo_addr(RTC_TR+0)
MOVT	R1, #hi_addr(RTC_TR+0)
STR	R4, [R1, #0]
; temp end address is: 16 (R4)
;RTC.c,94 :: 		RTC_CRbits.FMT = 0;               // Set FMT 24H format
MOVS	R2, #0
SXTB	R2, R2
MOVW	R1, #lo_addr(RTC_CRbits+0)
MOVT	R1, #hi_addr(RTC_CRbits+0)
STR	R2, [R1, #0]
;RTC.c,95 :: 		RTC_CRbits.WCKSEL = 0;            // Set RTC/16 clock
MOVS	R3, #0
MOVW	R2, #lo_addr(RTC_CRbits+0)
MOVT	R2, #hi_addr(RTC_CRbits+0)
LDRB	R1, [R2, #0]
BFI	R1, R3, #0, #3
STRB	R1, [R2, #0]
;RTC.c,97 :: 		RTC_ISR = 0x00000000;             // Exit initialization mode
MOVS	R2, #0
MOVW	R1, #lo_addr(RTC_ISR+0)
MOVT	R1, #hi_addr(RTC_ISR+0)
STR	R2, [R1, #0]
;RTC.c,99 :: 		RTC_WPR = 0xFF;                   // Enable the write protection for RTC registers
MOVS	R2, #255
MOVW	R1, #lo_addr(RTC_WPR+0)
MOVT	R1, #hi_addr(RTC_WPR+0)
STR	R2, [R1, #0]
;RTC.c,100 :: 		}
L_end_RTC_Write:
LDR	LR, [SP, #0]
ADD	SP, SP, #16
BX	LR
; end of _RTC_Write
_RTC_Read:
;RTC.c,104 :: 		void RTC_Read(TTime *RTCC_Time) {
; RTCC_Time start address is: 0 (R0)
SUB	SP, SP, #20
STR	LR, [SP, #0]
MOV	R4, R0
; RTCC_Time end address is: 0 (R0)
; RTCC_Time start address is: 16 (R4)
;RTC.c,107 :: 		RTC_Time = RTC_TR;              // Read the time register
MOVW	R1, #lo_addr(RTC_TR+0)
MOVT	R1, #hi_addr(RTC_TR+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(_RTC_Time+0)
MOVT	R1, #hi_addr(_RTC_Time+0)
STR	R1, [SP, #16]
STR	R2, [R1, #0]
;RTC.c,108 :: 		RTC_Date = RTC_DR;              // Read the date register
MOVW	R1, #lo_addr(RTC_DR+0)
MOVT	R1, #hi_addr(RTC_DR+0)
LDR	R1, [R1, #0]
MOVW	R2, #lo_addr(_RTC_Date+0)
MOVT	R2, #hi_addr(_RTC_Date+0)
STR	R2, [SP, #12]
STR	R1, [R2, #0]
;RTC.c,111 :: 		RTCC_Time->year = Bcd2Dec16((unsigned)((RTC_Date & 0xFFFF0000) >> 16));
MOV	R1, R4
STR	R1, [SP, #8]
MOV	R1, R2
LDR	R2, [R1, #0]
MOVW	R1, #0
MOVT	R1, #65535
AND	R1, R2, R1, LSL #0
LSRS	R1, R1, #16
UXTH	R0, R1
BL	_Bcd2Dec16+0
LDR	R1, [SP, #8]
STRH	R0, [R1, #0]
;RTC.c,112 :: 		RTCC_Time->weekday = Bcd2Dec((short)((RTC_Date & 0x0000E000) >> 13));
ADDS	R2, R4, #2
LDR	R1, [SP, #12]
STR	R2, [SP, #8]
LDR	R1, [R1, #0]
AND	R1, R1, #57344
LSRS	R1, R1, #13
UXTB	R0, R1
BL	_Bcd2Dec+0
LDR	R1, [SP, #8]
STRB	R0, [R1, #0]
;RTC.c,113 :: 		RTCC_Time->month = Bcd2Dec((short)((RTC_Date & 0x00001F00) >> 8));
ADDS	R2, R4, #3
LDR	R1, [SP, #12]
STR	R2, [SP, #8]
LDR	R1, [R1, #0]
AND	R1, R1, #7936
LSRS	R1, R1, #8
UXTB	R0, R1
BL	_Bcd2Dec+0
LDR	R1, [SP, #8]
STRB	R0, [R1, #0]
;RTC.c,114 :: 		RTCC_Time->day = Bcd2Dec((short)(RTC_Date & 0x0000003F));
ADDS	R2, R4, #4
LDR	R1, [SP, #12]
STR	R2, [SP, #8]
LDR	R1, [R1, #0]
AND	R1, R1, #63
UXTB	R0, R1
BL	_Bcd2Dec+0
LDR	R1, [SP, #8]
STRB	R0, [R1, #0]
;RTC.c,117 :: 		RTCC_Time->hours = Bcd2Dec((short)((RTC_Time & 0x003F0000) >> 16));
ADDS	R2, R4, #5
LDR	R1, [SP, #16]
STR	R2, [SP, #8]
LDR	R1, [R1, #0]
AND	R1, R1, #4128768
LSRS	R1, R1, #16
UXTB	R0, R1
BL	_Bcd2Dec+0
LDR	R1, [SP, #8]
STRB	R0, [R1, #0]
;RTC.c,118 :: 		RTCC_Time->minutes = Bcd2Dec((short)((RTC_Time & 0x00007F00) >> 8));
ADDS	R2, R4, #6
LDR	R1, [SP, #16]
STR	R2, [SP, #8]
LDR	R1, [R1, #0]
AND	R1, R1, #32512
LSRS	R1, R1, #8
UXTB	R0, R1
BL	_Bcd2Dec+0
LDR	R1, [SP, #8]
STRB	R0, [R1, #0]
;RTC.c,119 :: 		RTCC_Time->seconds = Bcd2Dec((short)(RTC_Time & 0x0000007F));
ADDS	R2, R4, #7
; RTCC_Time end address is: 16 (R4)
LDR	R1, [SP, #16]
STR	R2, [SP, #8]
LDR	R1, [R1, #0]
AND	R1, R1, #127
UXTB	R0, R1
BL	_Bcd2Dec+0
LDR	R1, [SP, #8]
STRB	R0, [R1, #0]
;RTC.c,121 :: 		BufNum = GetBuffer();     // Get a free buffer
BL	_GetBuffer+0
; BufNum start address is: 40 (R10)
MOV	R10, R0
;RTC.c,122 :: 		sprintf(BufNum,"%04d/%02d/%02d %02d:%02d:%02d %d\r\n",MyTime.year,MyTime.month,MyTime.day,MyTime.hours,MyTime.minutes,MyTime.seconds,MyTime.weekday);
MOVW	R1, #lo_addr(_MyTime+2)
MOVT	R1, #hi_addr(_MyTime+2)
LDRB	R9, [R1, #0]
MOVW	R1, #lo_addr(_MyTime+7)
MOVT	R1, #hi_addr(_MyTime+7)
LDRB	R8, [R1, #0]
MOVW	R1, #lo_addr(_MyTime+6)
MOVT	R1, #hi_addr(_MyTime+6)
LDRB	R7, [R1, #0]
MOVW	R1, #lo_addr(_MyTime+5)
MOVT	R1, #hi_addr(_MyTime+5)
LDRB	R6, [R1, #0]
MOVW	R1, #lo_addr(_MyTime+4)
MOVT	R1, #hi_addr(_MyTime+4)
LDRB	R5, [R1, #0]
MOVW	R1, #lo_addr(_MyTime+3)
MOVT	R1, #hi_addr(_MyTime+3)
LDRB	R4, [R1, #0]
MOVW	R1, #lo_addr(_MyTime+0)
MOVT	R1, #hi_addr(_MyTime+0)
LDRH	R3, [R1, #0]
MOVW	R2, #lo_addr(?lstr_3_RTC+0)
MOVT	R2, #hi_addr(?lstr_3_RTC+0)
MOV	R1, R0
STR	R10, [SP, #4]
PUSH	36
PUSH	32
PUSH	(R7)
PUSH	(R6)
PUSH	(R5)
PUSH	(R4)
PUSH	(R3)
PUSH	(R2)
PUSH	(R1)
BL	_sprintf+0
ADD	SP, SP, #36
LDR	R10, [SP, #4]
;RTC.c,123 :: 		USB_PutQueue(BufNum);   // Display the buffer
MOV	R0, R10
; BufNum end address is: 40 (R10)
BL	_USB_PutQueue+0
;RTC.c,124 :: 		}
L_end_RTC_Read:
LDR	LR, [SP, #0]
ADD	SP, SP, #20
BX	LR
; end of _RTC_Read
_RTC_WriteSRAM:
;RTC.c,128 :: 		void RTC_WriteSRAM(unsigned short Reg, unsigned long Value) {
; Value start address is: 4 (R1)
; Reg start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; Value end address is: 4 (R1)
; Reg end address is: 0 (R0)
; Reg start address is: 0 (R0)
; Value start address is: 4 (R1)
;RTC.c,130 :: 		switch (Reg) {
IT	AL
BAL	L_RTC_WriteSRAM7
; Reg end address is: 0 (R0)
;RTC.c,131 :: 		case 0: RTC_BKP0R = Value; break;
L_RTC_WriteSRAM9:
MOVW	R2, #lo_addr(RTC_BKP0R+0)
MOVT	R2, #hi_addr(RTC_BKP0R+0)
STR	R1, [R2, #0]
; Value end address is: 4 (R1)
IT	AL
BAL	L_RTC_WriteSRAM8
;RTC.c,132 :: 		case 1: RTC_BKP1R = Value; break;
L_RTC_WriteSRAM10:
; Value start address is: 4 (R1)
MOVW	R2, #lo_addr(RTC_BKP1R+0)
MOVT	R2, #hi_addr(RTC_BKP1R+0)
STR	R1, [R2, #0]
; Value end address is: 4 (R1)
IT	AL
BAL	L_RTC_WriteSRAM8
;RTC.c,133 :: 		case 2: RTC_BKP2R = Value; break;
L_RTC_WriteSRAM11:
; Value start address is: 4 (R1)
MOVW	R2, #lo_addr(RTC_BKP2R+0)
MOVT	R2, #hi_addr(RTC_BKP2R+0)
STR	R1, [R2, #0]
; Value end address is: 4 (R1)
IT	AL
BAL	L_RTC_WriteSRAM8
;RTC.c,134 :: 		case 3: RTC_BKP3R = Value; break;
L_RTC_WriteSRAM12:
; Value start address is: 4 (R1)
MOVW	R2, #lo_addr(RTC_BKP3R+0)
MOVT	R2, #hi_addr(RTC_BKP3R+0)
STR	R1, [R2, #0]
; Value end address is: 4 (R1)
IT	AL
BAL	L_RTC_WriteSRAM8
;RTC.c,135 :: 		case 4: RTC_BKP4R = Value; break;
L_RTC_WriteSRAM13:
; Value start address is: 4 (R1)
MOVW	R2, #lo_addr(RTC_BKP4R+0)
MOVT	R2, #hi_addr(RTC_BKP4R+0)
STR	R1, [R2, #0]
; Value end address is: 4 (R1)
IT	AL
BAL	L_RTC_WriteSRAM8
;RTC.c,136 :: 		case 5: RTC_BKP5R = Value; break;
L_RTC_WriteSRAM14:
; Value start address is: 4 (R1)
MOVW	R2, #lo_addr(RTC_BKP5R+0)
MOVT	R2, #hi_addr(RTC_BKP5R+0)
STR	R1, [R2, #0]
; Value end address is: 4 (R1)
IT	AL
BAL	L_RTC_WriteSRAM8
;RTC.c,137 :: 		case 6: RTC_BKP6R = Value; break;
L_RTC_WriteSRAM15:
; Value start address is: 4 (R1)
MOVW	R2, #lo_addr(RTC_BKP6R+0)
MOVT	R2, #hi_addr(RTC_BKP6R+0)
STR	R1, [R2, #0]
; Value end address is: 4 (R1)
IT	AL
BAL	L_RTC_WriteSRAM8
;RTC.c,138 :: 		case 7: RTC_BKP7R = Value; break;
L_RTC_WriteSRAM16:
; Value start address is: 4 (R1)
MOVW	R2, #lo_addr(RTC_BKP7R+0)
MOVT	R2, #hi_addr(RTC_BKP7R+0)
STR	R1, [R2, #0]
; Value end address is: 4 (R1)
IT	AL
BAL	L_RTC_WriteSRAM8
;RTC.c,139 :: 		case 8: RTC_BKP8R = Value; break;
L_RTC_WriteSRAM17:
; Value start address is: 4 (R1)
MOVW	R2, #lo_addr(RTC_BKP8R+0)
MOVT	R2, #hi_addr(RTC_BKP8R+0)
STR	R1, [R2, #0]
; Value end address is: 4 (R1)
IT	AL
BAL	L_RTC_WriteSRAM8
;RTC.c,140 :: 		case 9: RTC_BKP9R = Value; break;
L_RTC_WriteSRAM18:
; Value start address is: 4 (R1)
MOVW	R2, #lo_addr(RTC_BKP9R+0)
MOVT	R2, #hi_addr(RTC_BKP9R+0)
STR	R1, [R2, #0]
; Value end address is: 4 (R1)
IT	AL
BAL	L_RTC_WriteSRAM8
;RTC.c,141 :: 		case 10: RTC_BKP10R = Value; break;
L_RTC_WriteSRAM19:
; Value start address is: 4 (R1)
MOVW	R2, #lo_addr(RTC_BKP10R+0)
MOVT	R2, #hi_addr(RTC_BKP10R+0)
STR	R1, [R2, #0]
; Value end address is: 4 (R1)
IT	AL
BAL	L_RTC_WriteSRAM8
;RTC.c,142 :: 		case 11: RTC_BKP11R = Value; break;
L_RTC_WriteSRAM20:
; Value start address is: 4 (R1)
MOVW	R2, #lo_addr(RTC_BKP11R+0)
MOVT	R2, #hi_addr(RTC_BKP11R+0)
STR	R1, [R2, #0]
; Value end address is: 4 (R1)
IT	AL
BAL	L_RTC_WriteSRAM8
;RTC.c,143 :: 		case 12: RTC_BKP12R = Value; break;
L_RTC_WriteSRAM21:
; Value start address is: 4 (R1)
MOVW	R2, #lo_addr(RTC_BKP12R+0)
MOVT	R2, #hi_addr(RTC_BKP12R+0)
STR	R1, [R2, #0]
; Value end address is: 4 (R1)
IT	AL
BAL	L_RTC_WriteSRAM8
;RTC.c,144 :: 		case 13: RTC_BKP13R = Value; break;
L_RTC_WriteSRAM22:
; Value start address is: 4 (R1)
MOVW	R2, #lo_addr(RTC_BKP13R+0)
MOVT	R2, #hi_addr(RTC_BKP13R+0)
STR	R1, [R2, #0]
; Value end address is: 4 (R1)
IT	AL
BAL	L_RTC_WriteSRAM8
;RTC.c,145 :: 		case 14: RTC_BKP14R = Value; break;
L_RTC_WriteSRAM23:
; Value start address is: 4 (R1)
MOVW	R2, #lo_addr(RTC_BKP14R+0)
MOVT	R2, #hi_addr(RTC_BKP14R+0)
STR	R1, [R2, #0]
; Value end address is: 4 (R1)
IT	AL
BAL	L_RTC_WriteSRAM8
;RTC.c,146 :: 		case 15: RTC_BKP15R = Value; break;
L_RTC_WriteSRAM24:
; Value start address is: 4 (R1)
MOVW	R2, #lo_addr(RTC_BKP15R+0)
MOVT	R2, #hi_addr(RTC_BKP15R+0)
STR	R1, [R2, #0]
; Value end address is: 4 (R1)
IT	AL
BAL	L_RTC_WriteSRAM8
;RTC.c,147 :: 		case 16: RTC_BKP16R = Value; break;
L_RTC_WriteSRAM25:
; Value start address is: 4 (R1)
MOVW	R2, #lo_addr(RTC_BKP16R+0)
MOVT	R2, #hi_addr(RTC_BKP16R+0)
STR	R1, [R2, #0]
; Value end address is: 4 (R1)
IT	AL
BAL	L_RTC_WriteSRAM8
;RTC.c,148 :: 		case 17: RTC_BKP17R = Value; break;
L_RTC_WriteSRAM26:
; Value start address is: 4 (R1)
MOVW	R2, #lo_addr(RTC_BKP17R+0)
MOVT	R2, #hi_addr(RTC_BKP17R+0)
STR	R1, [R2, #0]
; Value end address is: 4 (R1)
IT	AL
BAL	L_RTC_WriteSRAM8
;RTC.c,149 :: 		case 18: RTC_BKP18R = Value; break;
L_RTC_WriteSRAM27:
; Value start address is: 4 (R1)
MOVW	R2, #lo_addr(RTC_BKP18R+0)
MOVT	R2, #hi_addr(RTC_BKP18R+0)
STR	R1, [R2, #0]
; Value end address is: 4 (R1)
IT	AL
BAL	L_RTC_WriteSRAM8
;RTC.c,150 :: 		case 19: RTC_BKP19R = Value; break;
L_RTC_WriteSRAM28:
; Value start address is: 4 (R1)
MOVW	R2, #lo_addr(RTC_BKP19R+0)
MOVT	R2, #hi_addr(RTC_BKP19R+0)
STR	R1, [R2, #0]
; Value end address is: 4 (R1)
IT	AL
BAL	L_RTC_WriteSRAM8
;RTC.c,151 :: 		default: USB_PutQueue("Invalid reg address\r\n"); break;
L_RTC_WriteSRAM29:
MOVW	R2, #lo_addr(?lstr4_RTC+0)
MOVT	R2, #hi_addr(?lstr4_RTC+0)
MOV	R0, R2
BL	_USB_PutQueue+0
IT	AL
BAL	L_RTC_WriteSRAM8
;RTC.c,152 :: 		}
L_RTC_WriteSRAM7:
; Value start address is: 4 (R1)
; Reg start address is: 0 (R0)
CMP	R0, #0
IT	EQ
BEQ	L_RTC_WriteSRAM9
CMP	R0, #1
IT	EQ
BEQ	L_RTC_WriteSRAM10
CMP	R0, #2
IT	EQ
BEQ	L_RTC_WriteSRAM11
CMP	R0, #3
IT	EQ
BEQ	L_RTC_WriteSRAM12
CMP	R0, #4
IT	EQ
BEQ	L_RTC_WriteSRAM13
CMP	R0, #5
IT	EQ
BEQ	L_RTC_WriteSRAM14
CMP	R0, #6
IT	EQ
BEQ	L_RTC_WriteSRAM15
CMP	R0, #7
IT	EQ
BEQ	L_RTC_WriteSRAM16
CMP	R0, #8
IT	EQ
BEQ	L_RTC_WriteSRAM17
CMP	R0, #9
IT	EQ
BEQ	L_RTC_WriteSRAM18
CMP	R0, #10
IT	EQ
BEQ	L_RTC_WriteSRAM19
CMP	R0, #11
IT	EQ
BEQ	L_RTC_WriteSRAM20
CMP	R0, #12
IT	EQ
BEQ	L_RTC_WriteSRAM21
CMP	R0, #13
IT	EQ
BEQ	L_RTC_WriteSRAM22
CMP	R0, #14
IT	EQ
BEQ	L_RTC_WriteSRAM23
CMP	R0, #15
IT	EQ
BEQ	L_RTC_WriteSRAM24
CMP	R0, #16
IT	EQ
BEQ	L_RTC_WriteSRAM25
CMP	R0, #17
IT	EQ
BEQ	L_RTC_WriteSRAM26
CMP	R0, #18
IT	EQ
BEQ	L_RTC_WriteSRAM27
CMP	R0, #19
IT	EQ
BEQ	L_RTC_WriteSRAM28
; Reg end address is: 0 (R0)
; Value end address is: 4 (R1)
IT	AL
BAL	L_RTC_WriteSRAM29
L_RTC_WriteSRAM8:
;RTC.c,153 :: 		}
L_end_RTC_WriteSRAM:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _RTC_WriteSRAM
_RTC_ReadSRAM:
;RTC.c,157 :: 		unsigned long RTC_ReadSRAM(unsigned short Reg) {
; Reg start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; Reg end address is: 0 (R0)
; Reg start address is: 0 (R0)
;RTC.c,160 :: 		switch (Reg) {
IT	AL
BAL	L_RTC_ReadSRAM30
; Reg end address is: 0 (R0)
;RTC.c,161 :: 		case 0: Temp = RTC_BKP0R; break;
L_RTC_ReadSRAM32:
MOVW	R1, #lo_addr(RTC_BKP0R+0)
MOVT	R1, #hi_addr(RTC_BKP0R+0)
; Temp start address is: 0 (R0)
LDR	R0, [R1, #0]
; Temp end address is: 0 (R0)
IT	AL
BAL	L_RTC_ReadSRAM31
;RTC.c,162 :: 		case 1: Temp = RTC_BKP1R; break;
L_RTC_ReadSRAM33:
MOVW	R1, #lo_addr(RTC_BKP1R+0)
MOVT	R1, #hi_addr(RTC_BKP1R+0)
; Temp start address is: 0 (R0)
LDR	R0, [R1, #0]
; Temp end address is: 0 (R0)
IT	AL
BAL	L_RTC_ReadSRAM31
;RTC.c,163 :: 		case 2: Temp = RTC_BKP2R; break;
L_RTC_ReadSRAM34:
MOVW	R1, #lo_addr(RTC_BKP2R+0)
MOVT	R1, #hi_addr(RTC_BKP2R+0)
; Temp start address is: 0 (R0)
LDR	R0, [R1, #0]
; Temp end address is: 0 (R0)
IT	AL
BAL	L_RTC_ReadSRAM31
;RTC.c,164 :: 		case 3: Temp = RTC_BKP3R; break;
L_RTC_ReadSRAM35:
MOVW	R1, #lo_addr(RTC_BKP3R+0)
MOVT	R1, #hi_addr(RTC_BKP3R+0)
; Temp start address is: 0 (R0)
LDR	R0, [R1, #0]
; Temp end address is: 0 (R0)
IT	AL
BAL	L_RTC_ReadSRAM31
;RTC.c,165 :: 		case 4: Temp = RTC_BKP4R; break;
L_RTC_ReadSRAM36:
MOVW	R1, #lo_addr(RTC_BKP4R+0)
MOVT	R1, #hi_addr(RTC_BKP4R+0)
; Temp start address is: 0 (R0)
LDR	R0, [R1, #0]
; Temp end address is: 0 (R0)
IT	AL
BAL	L_RTC_ReadSRAM31
;RTC.c,166 :: 		case 5: Temp = RTC_BKP5R; break;
L_RTC_ReadSRAM37:
MOVW	R1, #lo_addr(RTC_BKP5R+0)
MOVT	R1, #hi_addr(RTC_BKP5R+0)
; Temp start address is: 0 (R0)
LDR	R0, [R1, #0]
; Temp end address is: 0 (R0)
IT	AL
BAL	L_RTC_ReadSRAM31
;RTC.c,167 :: 		case 6: Temp = RTC_BKP6R; break;
L_RTC_ReadSRAM38:
MOVW	R1, #lo_addr(RTC_BKP6R+0)
MOVT	R1, #hi_addr(RTC_BKP6R+0)
; Temp start address is: 0 (R0)
LDR	R0, [R1, #0]
; Temp end address is: 0 (R0)
IT	AL
BAL	L_RTC_ReadSRAM31
;RTC.c,168 :: 		case 7: Temp = RTC_BKP7R; break;
L_RTC_ReadSRAM39:
MOVW	R1, #lo_addr(RTC_BKP7R+0)
MOVT	R1, #hi_addr(RTC_BKP7R+0)
; Temp start address is: 0 (R0)
LDR	R0, [R1, #0]
; Temp end address is: 0 (R0)
IT	AL
BAL	L_RTC_ReadSRAM31
;RTC.c,169 :: 		case 8: Temp = RTC_BKP8R; break;
L_RTC_ReadSRAM40:
MOVW	R1, #lo_addr(RTC_BKP8R+0)
MOVT	R1, #hi_addr(RTC_BKP8R+0)
; Temp start address is: 0 (R0)
LDR	R0, [R1, #0]
; Temp end address is: 0 (R0)
IT	AL
BAL	L_RTC_ReadSRAM31
;RTC.c,170 :: 		case 9: Temp = RTC_BKP9R; break;
L_RTC_ReadSRAM41:
MOVW	R1, #lo_addr(RTC_BKP9R+0)
MOVT	R1, #hi_addr(RTC_BKP9R+0)
; Temp start address is: 0 (R0)
LDR	R0, [R1, #0]
; Temp end address is: 0 (R0)
IT	AL
BAL	L_RTC_ReadSRAM31
;RTC.c,171 :: 		case 10: Temp = RTC_BKP10R; break;
L_RTC_ReadSRAM42:
MOVW	R1, #lo_addr(RTC_BKP10R+0)
MOVT	R1, #hi_addr(RTC_BKP10R+0)
; Temp start address is: 0 (R0)
LDR	R0, [R1, #0]
; Temp end address is: 0 (R0)
IT	AL
BAL	L_RTC_ReadSRAM31
;RTC.c,172 :: 		case 11: Temp = RTC_BKP11R; break;
L_RTC_ReadSRAM43:
MOVW	R1, #lo_addr(RTC_BKP11R+0)
MOVT	R1, #hi_addr(RTC_BKP11R+0)
; Temp start address is: 0 (R0)
LDR	R0, [R1, #0]
; Temp end address is: 0 (R0)
IT	AL
BAL	L_RTC_ReadSRAM31
;RTC.c,173 :: 		case 12: Temp = RTC_BKP12R; break;
L_RTC_ReadSRAM44:
MOVW	R1, #lo_addr(RTC_BKP12R+0)
MOVT	R1, #hi_addr(RTC_BKP12R+0)
; Temp start address is: 0 (R0)
LDR	R0, [R1, #0]
; Temp end address is: 0 (R0)
IT	AL
BAL	L_RTC_ReadSRAM31
;RTC.c,174 :: 		case 13: Temp = RTC_BKP13R; break;
L_RTC_ReadSRAM45:
MOVW	R1, #lo_addr(RTC_BKP13R+0)
MOVT	R1, #hi_addr(RTC_BKP13R+0)
; Temp start address is: 0 (R0)
LDR	R0, [R1, #0]
; Temp end address is: 0 (R0)
IT	AL
BAL	L_RTC_ReadSRAM31
;RTC.c,175 :: 		case 14: Temp = RTC_BKP14R; break;
L_RTC_ReadSRAM46:
MOVW	R1, #lo_addr(RTC_BKP14R+0)
MOVT	R1, #hi_addr(RTC_BKP14R+0)
; Temp start address is: 0 (R0)
LDR	R0, [R1, #0]
; Temp end address is: 0 (R0)
IT	AL
BAL	L_RTC_ReadSRAM31
;RTC.c,176 :: 		case 15: Temp = RTC_BKP15R; break;
L_RTC_ReadSRAM47:
MOVW	R1, #lo_addr(RTC_BKP15R+0)
MOVT	R1, #hi_addr(RTC_BKP15R+0)
; Temp start address is: 0 (R0)
LDR	R0, [R1, #0]
; Temp end address is: 0 (R0)
IT	AL
BAL	L_RTC_ReadSRAM31
;RTC.c,177 :: 		case 16: Temp = RTC_BKP16R; break;
L_RTC_ReadSRAM48:
MOVW	R1, #lo_addr(RTC_BKP16R+0)
MOVT	R1, #hi_addr(RTC_BKP16R+0)
; Temp start address is: 0 (R0)
LDR	R0, [R1, #0]
; Temp end address is: 0 (R0)
IT	AL
BAL	L_RTC_ReadSRAM31
;RTC.c,178 :: 		case 17: Temp = RTC_BKP17R; break;
L_RTC_ReadSRAM49:
MOVW	R1, #lo_addr(RTC_BKP17R+0)
MOVT	R1, #hi_addr(RTC_BKP17R+0)
; Temp start address is: 0 (R0)
LDR	R0, [R1, #0]
; Temp end address is: 0 (R0)
IT	AL
BAL	L_RTC_ReadSRAM31
;RTC.c,179 :: 		case 18: Temp = RTC_BKP18R; break;
L_RTC_ReadSRAM50:
MOVW	R1, #lo_addr(RTC_BKP18R+0)
MOVT	R1, #hi_addr(RTC_BKP18R+0)
; Temp start address is: 0 (R0)
LDR	R0, [R1, #0]
; Temp end address is: 0 (R0)
IT	AL
BAL	L_RTC_ReadSRAM31
;RTC.c,180 :: 		case 19: Temp = RTC_BKP19R; break;
L_RTC_ReadSRAM51:
MOVW	R1, #lo_addr(RTC_BKP19R+0)
MOVT	R1, #hi_addr(RTC_BKP19R+0)
; Temp start address is: 0 (R0)
LDR	R0, [R1, #0]
; Temp end address is: 0 (R0)
IT	AL
BAL	L_RTC_ReadSRAM31
;RTC.c,181 :: 		default: USB_PutQueue("Invalid reg address\r\n"); Temp = 0; break;
L_RTC_ReadSRAM52:
MOVW	R1, #lo_addr(?lstr5_RTC+0)
MOVT	R1, #hi_addr(?lstr5_RTC+0)
MOV	R0, R1
BL	_USB_PutQueue+0
; Temp start address is: 0 (R0)
MOVS	R0, #0
; Temp end address is: 0 (R0)
IT	AL
BAL	L_RTC_ReadSRAM31
;RTC.c,182 :: 		}
L_RTC_ReadSRAM30:
; Reg start address is: 0 (R0)
CMP	R0, #0
IT	EQ
BEQ	L_RTC_ReadSRAM32
CMP	R0, #1
IT	EQ
BEQ	L_RTC_ReadSRAM33
CMP	R0, #2
IT	EQ
BEQ	L_RTC_ReadSRAM34
CMP	R0, #3
IT	EQ
BEQ	L_RTC_ReadSRAM35
CMP	R0, #4
IT	EQ
BEQ	L_RTC_ReadSRAM36
CMP	R0, #5
IT	EQ
BEQ	L_RTC_ReadSRAM37
CMP	R0, #6
IT	EQ
BEQ	L_RTC_ReadSRAM38
CMP	R0, #7
IT	EQ
BEQ	L_RTC_ReadSRAM39
CMP	R0, #8
IT	EQ
BEQ	L_RTC_ReadSRAM40
CMP	R0, #9
IT	EQ
BEQ	L_RTC_ReadSRAM41
CMP	R0, #10
IT	EQ
BEQ	L_RTC_ReadSRAM42
CMP	R0, #11
IT	EQ
BEQ	L_RTC_ReadSRAM43
CMP	R0, #12
IT	EQ
BEQ	L_RTC_ReadSRAM44
CMP	R0, #13
IT	EQ
BEQ	L_RTC_ReadSRAM45
CMP	R0, #14
IT	EQ
BEQ	L_RTC_ReadSRAM46
CMP	R0, #15
IT	EQ
BEQ	L_RTC_ReadSRAM47
CMP	R0, #16
IT	EQ
BEQ	L_RTC_ReadSRAM48
CMP	R0, #17
IT	EQ
BEQ	L_RTC_ReadSRAM49
CMP	R0, #18
IT	EQ
BEQ	L_RTC_ReadSRAM50
CMP	R0, #19
IT	EQ
BEQ	L_RTC_ReadSRAM51
; Reg end address is: 0 (R0)
IT	AL
BAL	L_RTC_ReadSRAM52
L_RTC_ReadSRAM31:
;RTC.c,183 :: 		return Temp;
; Temp start address is: 0 (R0)
; Temp end address is: 0 (R0)
;RTC.c,184 :: 		}
L_end_RTC_ReadSRAM:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _RTC_ReadSRAM
_RTC_WriteCCR:
;RTC.c,191 :: 		void RTC_WriteCCR(char Cal) {
; Cal start address is: 0 (R0)
; Cal end address is: 0 (R0)
; Cal start address is: 0 (R0)
;RTC.c,193 :: 		PWR_CR.DBP = 1;                   // Enable access to RTC, RTC backup regs, SRAM
MOVS	R2, #1
SXTB	R2, R2
MOVW	R1, #lo_addr(PWR_CR+0)
MOVT	R1, #hi_addr(PWR_CR+0)
STR	R2, [R1, #0]
;RTC.c,194 :: 		RTC_WPR = 0xCA;                   // Unlock write protection
MOVS	R2, #202
MOVW	R1, #lo_addr(RTC_WPR+0)
MOVT	R1, #hi_addr(RTC_WPR+0)
STR	R2, [R1, #0]
;RTC.c,195 :: 		RTC_WPR = 0x53;                   // Unlock write protection
MOVS	R2, #83
MOVW	R1, #lo_addr(RTC_WPR+0)
MOVT	R1, #hi_addr(RTC_WPR+0)
STR	R2, [R1, #0]
;RTC.c,196 :: 		RTC_ISR = 0x00000080;             // Set initialization mode (bit 7 of RTC_ISR)
MOVS	R2, #128
MOVW	R1, #lo_addr(RTC_ISR+0)
MOVT	R1, #hi_addr(RTC_ISR+0)
STR	R2, [R1, #0]
; Cal end address is: 0 (R0)
;RTC.c,197 :: 		while(RTC_ISR.INITF != 1) {};     // Wait for INITF (bit 6 of RTC_ISR) to come on
L_RTC_WriteCCR53:
; Cal start address is: 0 (R0)
MOVW	R2, #lo_addr(RTC_ISR+0)
MOVT	R2, #hi_addr(RTC_ISR+0)
LDR	R1, [R2, #0]
CMP	R1, #0
IT	NE
BNE	L_RTC_WriteCCR54
IT	AL
BAL	L_RTC_WriteCCR53
L_RTC_WriteCCR54:
;RTC.c,198 :: 		RTC_CALIBR = Cal;                 // Set calibration register with value supplied
MOVW	R1, #lo_addr(RTC_CALIBR+0)
MOVT	R1, #hi_addr(RTC_CALIBR+0)
STR	R0, [R1, #0]
; Cal end address is: 0 (R0)
;RTC.c,199 :: 		RTC_ISR = 0x00000000;             // Exit initialization mode
MOVS	R2, #0
MOVW	R1, #lo_addr(RTC_ISR+0)
MOVT	R1, #hi_addr(RTC_ISR+0)
STR	R2, [R1, #0]
;RTC.c,200 :: 		RTC_WPR = 0xFF;                   // Set write protection register lock
MOVS	R2, #255
MOVW	R1, #lo_addr(RTC_WPR+0)
MOVT	R1, #hi_addr(RTC_WPR+0)
STR	R2, [R1, #0]
;RTC.c,201 :: 		}
L_end_RTC_WriteCCR:
BX	LR
; end of _RTC_WriteCCR
_RTC_ReadCCR:
;RTC.c,205 :: 		void RTC_ReadCCR(void) {
SUB	SP, SP, #8
STR	LR, [SP, #0]
;RTC.c,208 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;RTC.c,209 :: 		sprintf(BufNum,"%04X\r\n",RTC_CALIBR);
MOVW	R1, #lo_addr(RTC_CALIBR+0)
MOVT	R1, #hi_addr(RTC_CALIBR+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_6_RTC+0)
MOVT	R1, #hi_addr(?lstr_6_RTC+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;RTC.c,210 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;RTC.c,211 :: 		}
L_end_RTC_ReadCCR:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _RTC_ReadCCR
_RTC_ReadISR:
;RTC.c,215 :: 		void RTC_ReadISR(void) {
SUB	SP, SP, #8
STR	LR, [SP, #0]
;RTC.c,218 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;RTC.c,219 :: 		sprintf(BufNum,"%08LX\r\n",RTC_ISR);
MOVW	R1, #lo_addr(RTC_ISR+0)
MOVT	R1, #hi_addr(RTC_ISR+0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_7_RTC+0)
MOVT	R1, #hi_addr(?lstr_7_RTC+0)
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
;RTC.c,220 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_USB_PutQueue+0
;RTC.c,221 :: 		}
L_end_RTC_ReadISR:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _RTC_ReadISR
