/**************************************************************************************************
  RTC.h
  Real Time Clock functin prototypes
**************************************************************************************************/
#ifndef RTC_H
#define RTC_H


// Defines


// Time struct with am/pm
typedef struct Time {
     unsigned int   year;
     unsigned short weekday;  // 0=invalid, 1=Monday...7=Sunday
     unsigned short month;
     unsigned short day;      //
     unsigned short hours;
     unsigned short minutes;
     unsigned short seconds;
     unsigned short ampm;     // 0=AM or 24 hour format, 1=PM
} TTime;



// Function Prototypes
void RTC_Initialize(void);
void RTC_Write(TTime *RTCC_Time);
void RTC_Read(TTime *RTCC_Time);

void RTC_WriteSRAM(unsigned short Reg, unsigned long Value);
unsigned long RTC_ReadSRAM(unsigned short Reg);

void RTC_WriteCCR(char Cal);
void RTC_ReadCCR(void);
void RTC_ReadISR(void);



#endif