_SystemTimerInterrupt:
;Timers.c,24 :: 		void SystemTimerInterrupt() iv IVT_INT_SysTick ics ICS_AUTO {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;Timers.c,25 :: 		if (COUNTFLAG_bit) {              // Interrupts every millisecond
MOVW	R0, #lo_addr(COUNTFLAG_bit+0)
MOVT	R0, #hi_addr(COUNTFLAG_bit+0)
LDR	R1, [R0, #0]
UBFX	R0, R1, BitPos(COUNTFLAG_bit+0), #1
CMP	R0, #0
IT	EQ
BEQ	L_SystemTimerInterrupt0
;Timers.c,26 :: 		irqhandler_timer();           // Service timer pool
BL	_irqhandler_timer+0
;Timers.c,28 :: 		Msec += 1;                    // Increment millisecond counter
MOVW	R2, #lo_addr(_Msec+0)
MOVT	R2, #hi_addr(_Msec+0)
LDRH	R0, [R2, #0]
ADDS	R1, R0, #1
UXTH	R1, R1
STRH	R1, [R2, #0]
;Timers.c,29 :: 		if (Msec > 999) {             // When counter goes to 1000
MOVW	R0, #999
CMP	R1, R0
IT	LS
BLS	L_SystemTimerInterrupt1
;Timers.c,30 :: 		Msec = 0;                 // Set it to 0
MOVS	R1, #0
MOVW	R0, #lo_addr(_Msec+0)
MOVT	R0, #hi_addr(_Msec+0)
STRH	R1, [R0, #0]
;Timers.c,31 :: 		TimerFlag = 1;            // Set 1 second flag
MOVS	R1, #1
SXTH	R1, R1
MOVW	R0, #lo_addr(_TimerFlag+0)
MOVT	R0, #hi_addr(_TimerFlag+0)
STRH	R1, [R0, #0]
;Timers.c,32 :: 		}
L_SystemTimerInterrupt1:
;Timers.c,33 :: 		}
L_SystemTimerInterrupt0:
;Timers.c,34 :: 		}
L_end_SystemTimerInterrupt:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _SystemTimerInterrupt
_TimerInit:
;Timers.c,38 :: 		void TimerInit() {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;Timers.c,39 :: 		init_timerpool();                 // Make all timers free
BL	_init_timerpool+0
;Timers.c,44 :: 		NVIC_SYSTICKRVR = 15000;          // Set reload value register for 120MHz clock
MOVW	R1, #15000
MOVW	R0, #lo_addr(NVIC_SYSTICKRVR+0)
MOVT	R0, #hi_addr(NVIC_SYSTICKRVR+0)
STR	R1, [R0, #0]
;Timers.c,46 :: 		NVIC_SYSTICKCVR = 0;              // Reset timer counter
MOVS	R1, #0
MOVW	R0, #lo_addr(NVIC_SYSTICKCVR+0)
MOVT	R0, #hi_addr(NVIC_SYSTICKCVR+0)
STR	R1, [R0, #0]
;Timers.c,47 :: 		ENABLE_SYSTICKCSR_bit = 1;        // Enable timer
MOVS	R2, #1
SXTB	R2, R2
MOVW	R1, #lo_addr(ENABLE_SYSTICKCSR_bit+0)
MOVT	R1, #hi_addr(ENABLE_SYSTICKCSR_bit+0)
LDR	R0, [R1, #0]
BFI	R0, R2, BitPos(ENABLE_SYSTICKCSR_bit+0), #1
STR	R0, [R1, #0]
;Timers.c,48 :: 		TICKINT_bit = 1;                  // Enable timer interrupt
MOVW	R1, #lo_addr(TICKINT_bit+0)
MOVT	R1, #hi_addr(TICKINT_bit+0)
LDR	R0, [R1, #0]
BFI	R0, R2, BitPos(TICKINT_bit+0), #1
STR	R0, [R1, #0]
;Timers.c,49 :: 		}
L_end_TimerInit:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _TimerInit
_TimerCheck:
;Timers.c,53 :: 		void TimerCheck() {
;Timers.c,54 :: 		if (TimerFlag == 1) {
MOVW	R0, #lo_addr(_TimerFlag+0)
MOVT	R0, #hi_addr(_TimerFlag+0)
LDRSH	R0, [R0, #0]
CMP	R0, #1
IT	NE
BNE	L_TimerCheck2
;Timers.c,55 :: 		TimerFlag = 0;                // Reset 1 second flag
MOVS	R1, #0
SXTH	R1, R1
MOVW	R0, #lo_addr(_TimerFlag+0)
MOVT	R0, #hi_addr(_TimerFlag+0)
STRH	R1, [R0, #0]
;Timers.c,57 :: 		}
L_TimerCheck2:
;Timers.c,58 :: 		}
L_end_TimerCheck:
BX	LR
; end of _TimerCheck
_init_timerpool:
;Timers.c,89 :: 		void init_timerpool(void) {
;Timers.c,92 :: 		for (i=0; i < NUMTIMERS; i++) {
; i start address is: 8 (R2)
MOVS	R2, #0
; i end address is: 8 (R2)
L_init_timerpool3:
; i start address is: 8 (R2)
CMP	R2, #10
IT	CS
BCS	L_init_timerpool4
;Timers.c,93 :: 		TimerPool[i].TimerField = 0;
LSLS	R1, R2, #3
MOVW	R0, #lo_addr(_TimerPool+0)
MOVT	R0, #hi_addr(_TimerPool+0)
ADDS	R1, R0, R1
MOVS	R0, #0
STR	R0, [R1, #0]
;Timers.c,94 :: 		TimerPool[i].Free = TRUE;
LSLS	R1, R2, #3
MOVW	R0, #lo_addr(_TimerPool+0)
MOVT	R0, #hi_addr(_TimerPool+0)
ADDS	R0, R0, R1
ADDS	R1, R0, #4
MOVS	R0, #1
STRB	R0, [R1, #0]
;Timers.c,92 :: 		for (i=0; i < NUMTIMERS; i++) {
ADDS	R2, R2, #1
UXTB	R2, R2
;Timers.c,95 :: 		}
; i end address is: 8 (R2)
IT	AL
BAL	L_init_timerpool3
L_init_timerpool4:
;Timers.c,96 :: 		}
L_end_init_timerpool:
BX	LR
; end of _init_timerpool
_get_timer:
;Timers.c,104 :: 		unsigned short int get_timer(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;Timers.c,107 :: 		for (i=0; i < NUMTIMERS; i++) {
; i start address is: 8 (R2)
MOVS	R2, #0
; i end address is: 8 (R2)
L_get_timer6:
; i start address is: 8 (R2)
CMP	R2, #10
IT	CS
BCS	L_get_timer7
;Timers.c,108 :: 		if (TimerPool[i].Free == TRUE) {  // If a free timer is found
LSLS	R1, R2, #3
MOVW	R0, #lo_addr(_TimerPool+0)
MOVT	R0, #hi_addr(_TimerPool+0)
ADDS	R0, R0, R1
ADDS	R0, R0, #4
LDRB	R0, [R0, #0]
CMP	R0, #1
IT	NE
BNE	L_get_timer9
;Timers.c,109 :: 		TimerPool[i].Free = FALSE;    // Mark it reserved
LSLS	R1, R2, #3
MOVW	R0, #lo_addr(_TimerPool+0)
MOVT	R0, #hi_addr(_TimerPool+0)
ADDS	R0, R0, R1
ADDS	R1, R0, #4
MOVS	R0, #0
STRB	R0, [R1, #0]
;Timers.c,110 :: 		return i;                     // Return timer handle
UXTB	R0, R2
; i end address is: 8 (R2)
IT	AL
BAL	L_end_get_timer
;Timers.c,111 :: 		}
L_get_timer9:
;Timers.c,107 :: 		for (i=0; i < NUMTIMERS; i++) {
; i start address is: 8 (R2)
ADDS	R2, R2, #1
UXTB	R2, R2
;Timers.c,112 :: 		}
; i end address is: 8 (R2)
IT	AL
BAL	L_get_timer6
L_get_timer7:
;Timers.c,115 :: 		USB_PutQueue("TIMERS: No Timers, Resetting..\r\n");
MOVW	R0, #lo_addr(?lstr1_Timers+0)
MOVT	R0, #hi_addr(?lstr1_Timers+0)
BL	_USB_PutQueue+0
;Timers.c,117 :: 		SystemReset();
BL	_SystemReset+0
;Timers.c,118 :: 		return (0);
MOVS	R0, #0
;Timers.c,119 :: 		}
L_end_get_timer:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _get_timer
_free_timer:
;Timers.c,127 :: 		void free_timer(unsigned short int nbr) {
; nbr start address is: 0 (R0)
; nbr end address is: 0 (R0)
; nbr start address is: 0 (R0)
;Timers.c,128 :: 		if (nbr > (NUMTIMERS-1))          // Make a simple check
CMP	R0, #9
IT	LS
BLS	L_free_timer10
; nbr end address is: 0 (R0)
;Timers.c,129 :: 		return;
IT	AL
BAL	L_end_free_timer
L_free_timer10:
;Timers.c,131 :: 		TimerPool[nbr].Free = TRUE;
; nbr start address is: 0 (R0)
LSLS	R2, R0, #3
; nbr end address is: 0 (R0)
MOVW	R1, #lo_addr(_TimerPool+0)
MOVT	R1, #hi_addr(_TimerPool+0)
ADDS	R1, R1, R2
ADDS	R2, R1, #4
MOVS	R1, #1
STRB	R1, [R2, #0]
;Timers.c,132 :: 		}
L_end_free_timer:
BX	LR
; end of _free_timer
_set_timer:
;Timers.c,141 :: 		void set_timer(unsigned short int nbr, unsigned long int tout) {
; tout start address is: 4 (R1)
; nbr start address is: 0 (R0)
; tout end address is: 4 (R1)
; nbr end address is: 0 (R0)
; nbr start address is: 0 (R0)
; tout start address is: 4 (R1)
;Timers.c,142 :: 		if (nbr > (NUMTIMERS-1))          // Make a simple check
CMP	R0, #9
IT	LS
BLS	L_set_timer11
; nbr end address is: 0 (R0)
; tout end address is: 4 (R1)
;Timers.c,143 :: 		return;
IT	AL
BAL	L_end_set_timer
L_set_timer11:
;Timers.c,145 :: 		if (TimerPool[nbr].Free == TRUE)
; tout start address is: 4 (R1)
; nbr start address is: 0 (R0)
LSLS	R3, R0, #3
MOVW	R2, #lo_addr(_TimerPool+0)
MOVT	R2, #hi_addr(_TimerPool+0)
ADDS	R2, R2, R3
ADDS	R2, R2, #4
LDRB	R2, [R2, #0]
CMP	R2, #1
IT	NE
BNE	L_set_timer12
; nbr end address is: 0 (R0)
; tout end address is: 4 (R1)
;Timers.c,146 :: 		return;
IT	AL
BAL	L_end_set_timer
L_set_timer12:
;Timers.c,148 :: 		TimerPool[nbr].TimerField = tout;
; tout start address is: 4 (R1)
; nbr start address is: 0 (R0)
LSLS	R3, R0, #3
; nbr end address is: 0 (R0)
MOVW	R2, #lo_addr(_TimerPool+0)
MOVT	R2, #hi_addr(_TimerPool+0)
ADDS	R2, R2, R3
STR	R1, [R2, #0]
; tout end address is: 4 (R1)
;Timers.c,149 :: 		}
L_end_set_timer:
BX	LR
; end of _set_timer
_check_timer:
;Timers.c,157 :: 		unsigned long int check_timer(unsigned short int nbr) {
; nbr start address is: 0 (R0)
; nbr end address is: 0 (R0)
; nbr start address is: 0 (R0)
;Timers.c,158 :: 		return TimerPool[nbr].TimerField;
LSLS	R2, R0, #3
; nbr end address is: 0 (R0)
MOVW	R1, #lo_addr(_TimerPool+0)
MOVT	R1, #hi_addr(_TimerPool+0)
ADDS	R1, R1, R2
LDR	R1, [R1, #0]
MOV	R0, R1
;Timers.c,159 :: 		}
L_end_check_timer:
BX	LR
; end of _check_timer
_irqhandler_timer:
;Timers.c,167 :: 		void irqhandler_timer(void) {
;Timers.c,170 :: 		for (i=0; i<NUMTIMERS; i++) {
; i start address is: 8 (R2)
MOVS	R2, #0
; i end address is: 8 (R2)
L_irqhandler_timer13:
; i start address is: 8 (R2)
CMP	R2, #10
IT	CS
BCS	L_irqhandler_timer14
;Timers.c,171 :: 		if (TimerPool[i].Free == FALSE && TimerPool[i].TimerField != 0)
LSLS	R1, R2, #3
MOVW	R0, #lo_addr(_TimerPool+0)
MOVT	R0, #hi_addr(_TimerPool+0)
ADDS	R0, R0, R1
ADDS	R0, R0, #4
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L__irqhandler_timer21
LSLS	R1, R2, #3
MOVW	R0, #lo_addr(_TimerPool+0)
MOVT	R0, #hi_addr(_TimerPool+0)
ADDS	R0, R0, R1
LDR	R0, [R0, #0]
CMP	R0, #0
IT	EQ
BEQ	L__irqhandler_timer20
L__irqhandler_timer19:
;Timers.c,172 :: 		TimerPool[i].TimerField--;
LSLS	R1, R2, #3
MOVW	R0, #lo_addr(_TimerPool+0)
MOVT	R0, #hi_addr(_TimerPool+0)
ADDS	R1, R0, R1
LDR	R0, [R1, #0]
SUBS	R0, R0, #1
STR	R0, [R1, #0]
;Timers.c,171 :: 		if (TimerPool[i].Free == FALSE && TimerPool[i].TimerField != 0)
L__irqhandler_timer21:
L__irqhandler_timer20:
;Timers.c,170 :: 		for (i=0; i<NUMTIMERS; i++) {
ADDS	R2, R2, #1
UXTB	R2, R2
;Timers.c,173 :: 		}
; i end address is: 8 (R2)
IT	AL
BAL	L_irqhandler_timer13
L_irqhandler_timer14:
;Timers.c,174 :: 		}
L_end_irqhandler_timer:
BX	LR
; end of _irqhandler_timer
_Timer6Interrupt:
;Timers.c,190 :: 		void Timer6Interrupt() iv IVT_INT_TIM6_DAC ics ICS_AUTO {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;Timers.c,191 :: 		UIF_TIM6_SR_bit = 0;  // Clear Update Interrupt Flag in TIM6_SR
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(UIF_TIM6_SR_bit+0)
MOVT	R0, #hi_addr(UIF_TIM6_SR_bit+0)
STR	R1, [R0, #0]
;Timers.c,195 :: 		DoSine();  // Generate Sine wave on DAC1 (PA4)
BL	_DoSine+0
;Timers.c,197 :: 		}
L_end_Timer6Interrupt:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Timer6Interrupt
_Timer6_Initialize:
;Timers.c,201 :: 		void Timer6_Initialize(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;Timers.c,202 :: 		TIM6EN_bit = 1;           // Enable TIM6 clock in RCC_APB1ENR
MOVS	R3, #1
SXTB	R3, R3
MOVW	R0, #lo_addr(TIM6EN_bit+0)
MOVT	R0, #hi_addr(TIM6EN_bit+0)
STR	R3, [R0, #0]
;Timers.c,223 :: 		TIM6_PSC = 99;            // Set the prscaler to 99 (99 + 1 = divide by 100)
MOVS	R1, #99
MOVW	R0, #lo_addr(TIM6_PSC+0)
MOVT	R0, #hi_addr(TIM6_PSC+0)
STR	R1, [R0, #0]
;Timers.c,224 :: 		TIM6_ARR = 10;            // Set the auto-reload register to 10
MOVS	R1, #10
MOVW	R0, #lo_addr(TIM6_ARR+0)
MOVT	R0, #hi_addr(TIM6_ARR+0)
STR	R1, [R0, #0]
;Timers.c,226 :: 		TIM6_CR2bits.MMS = 0x2;   // Update event is selected as a trigger output (TRGO) in TIM6_CR2
MOVS	R2, #2
MOVW	R1, #lo_addr(TIM6_CR2bits+0)
MOVT	R1, #hi_addr(TIM6_CR2bits+0)
LDRB	R0, [R1, #0]
BFI	R0, R2, #4, #3
STRB	R0, [R1, #0]
;Timers.c,227 :: 		CEN_TIM6_CR1_bit = 1;     // Enable counter in TIM6_CR1
MOVW	R0, #lo_addr(CEN_TIM6_CR1_bit+0)
MOVT	R0, #hi_addr(CEN_TIM6_CR1_bit+0)
STR	R3, [R0, #0]
;Timers.c,228 :: 		UIE_TIM6_DIER_bit = 1;    // Enable TIM6 interrupts in TIM6_DIER
MOVW	R0, #lo_addr(UIE_TIM6_DIER_bit+0)
MOVT	R0, #hi_addr(UIE_TIM6_DIER_bit+0)
STR	R3, [R0, #0]
;Timers.c,229 :: 		NVIC_IntEnable(IVT_INT_TIM6_DAC);  // Allow interrupts in NVIC
MOVW	R0, #70
BL	_NVIC_IntEnable+0
;Timers.c,230 :: 		}
L_end_Timer6_Initialize:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Timer6_Initialize
_Timer7Interrupt:
;Timers.c,234 :: 		void Timer7Interrupt() iv IVT_INT_TIM7 ics ICS_AUTO {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;Timers.c,235 :: 		UIF_TIM7_SR_bit = 0;  // Clear Update Interrupt Flag in TIM7_SR
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(UIF_TIM7_SR_bit+0)
MOVT	R0, #hi_addr(UIF_TIM7_SR_bit+0)
STR	R1, [R0, #0]
;Timers.c,236 :: 		USB_PutQueue("Timer 7 interrupt\r\n");  // Diagnostic
MOVW	R0, #lo_addr(?lstr2_Timers+0)
MOVT	R0, #hi_addr(?lstr2_Timers+0)
BL	_USB_PutQueue+0
;Timers.c,237 :: 		}
L_end_Timer7Interrupt:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Timer7Interrupt
_Timer7_Initialize:
;Timers.c,241 :: 		void Timer7_Initialize(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;Timers.c,242 :: 		TIM7EN_bit = 1;           // Enable TIM7 clock in RCC_APB1ENR
MOVS	R3, #1
SXTB	R3, R3
MOVW	R0, #lo_addr(TIM7EN_bit+0)
MOVT	R0, #hi_addr(TIM7EN_bit+0)
STR	R3, [R0, #0]
;Timers.c,243 :: 		TIM7_PSC = 5999;          // Set the prescaler register to divide by 5999+1=6000
MOVW	R1, #5999
MOVW	R0, #lo_addr(TIM7_PSC+0)
MOVT	R0, #hi_addr(TIM7_PSC+0)
STR	R1, [R0, #0]
;Timers.c,244 :: 		TIM7_ARR = 10000;         // Set the auto-reload register to time out in 1 second
MOVW	R1, #10000
MOVW	R0, #lo_addr(TIM7_ARR+0)
MOVT	R0, #hi_addr(TIM7_ARR+0)
STR	R1, [R0, #0]
;Timers.c,245 :: 		TIM7_CR2bits.MMS = 0x2;   // Update event is selected as a trigger output (TRGO) in TIM7_CR2
MOVS	R2, #2
MOVW	R1, #lo_addr(TIM7_CR2bits+0)
MOVT	R1, #hi_addr(TIM7_CR2bits+0)
LDRB	R0, [R1, #0]
BFI	R0, R2, #4, #3
STRB	R0, [R1, #0]
;Timers.c,246 :: 		CEN_TIM7_CR1_bit = 1;     // Enable counter in TIM7_CR1
MOVW	R0, #lo_addr(CEN_TIM7_CR1_bit+0)
MOVT	R0, #hi_addr(CEN_TIM7_CR1_bit+0)
STR	R3, [R0, #0]
;Timers.c,247 :: 		UIE_TIM7_DIER_bit = 1;    // Enable TIM7 interrupts in TIM7_DIER
MOVW	R0, #lo_addr(UIE_TIM7_DIER_bit+0)
MOVT	R0, #hi_addr(UIE_TIM7_DIER_bit+0)
STR	R3, [R0, #0]
;Timers.c,248 :: 		NVIC_IntEnable(IVT_INT_TIM7);  // Allow interrupts in NVIC
MOVW	R0, #71
BL	_NVIC_IntEnable+0
;Timers.c,249 :: 		}
L_end_Timer7_Initialize:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Timer7_Initialize
