#line 1 "C:/Users/Val/Desktop/MikroE/Example4/Timers.c"
#line 1 "c:/users/val/desktop/mikroe/example4/timers.h"
#line 9 "c:/users/val/desktop/mikroe/example4/timers.h"
void TimerInit();
void TimerCheck();
#line 31 "c:/users/val/desktop/mikroe/example4/timers.h"
struct timers {
 unsigned long int TimerField;
 unsigned short int Free;
};
#line 43 "c:/users/val/desktop/mikroe/example4/timers.h"
void init_timerpool(void);
#line 52 "c:/users/val/desktop/mikroe/example4/timers.h"
unsigned short int get_timer(void);
#line 61 "c:/users/val/desktop/mikroe/example4/timers.h"
void free_timer(unsigned short int nbr);
#line 71 "c:/users/val/desktop/mikroe/example4/timers.h"
void set_timer(unsigned short int nbr, unsigned long int tout);
#line 80 "c:/users/val/desktop/mikroe/example4/timers.h"
unsigned long int check_timer(unsigned short int nbr);
#line 89 "c:/users/val/desktop/mikroe/example4/timers.h"
void irqhandler_timer(void);





void Timer6_Initialize(void);
void Timer7_Initialize(void);
#line 1 "c:/users/val/desktop/mikroe/example4/common.h"
#line 1 "c:/users/val/desktop/mikroe/example4/usb_driver.h"
#line 11 "c:/users/val/desktop/mikroe/example4/usb_driver.h"
typedef char *pnt;


typedef struct USB_TxStruct {
 unsigned int in;
 unsigned int out;
 pnt q[ 32 ];
}USB_TxStruct;



void USB_Init(void);
void USB_TxQueueInit(void);
void USB_PutQueue(char *msg);
void USB_CheckOut(void);
void USB_CheckIn(void);
#line 1 "c:/users/val/desktop/mikroe/example4/adc_dac.h"
#line 19 "c:/users/val/desktop/mikroe/example4/adc_dac.h"
void EnableDAC1(void);
void EnableDAC2(void);
void EnableDACs(void);
void SetDAC1(unsigned long Data);
void SetDAC2(unsigned long Data);
void SetDACs(unsigned long Data1, unsigned long Data2);
void SetDAC_Ch1(unsigned long Data);


void DAC1_Initialize(void);
void DAC1_Set(unsigned Value);
void DAC2_Initialize(void);
void DAC2_Set(unsigned Value);
void DoSine(void);



void DispDAC_CR(void);

void DispDAC_DHR12R1(void);
void DispDAC_DOR1(void);

void DispDAC_DHR12R2(void);
void DispDAC_DOR2(void);
#line 11 "C:/Users/Val/Desktop/MikroE/Example4/Timers.c"
int TimerFlag = 0;
unsigned int Msec = 0;
#line 24 "C:/Users/Val/Desktop/MikroE/Example4/Timers.c"
void SystemTimerInterrupt() iv IVT_INT_SysTick ics ICS_AUTO {
 if (COUNTFLAG_bit) {
 irqhandler_timer();

 Msec += 1;
 if (Msec > 999) {
 Msec = 0;
 TimerFlag = 1;
 }
 }
}
#line 38 "C:/Users/Val/Desktop/MikroE/Example4/Timers.c"
void TimerInit() {
 init_timerpool();




 NVIC_SYSTICKRVR = 15000;

 NVIC_SYSTICKCVR = 0;
 ENABLE_SYSTICKCSR_bit = 1;
 TICKINT_bit = 1;
}
#line 53 "C:/Users/Val/Desktop/MikroE/Example4/Timers.c"
void TimerCheck() {
 if (TimerFlag == 1) {
 TimerFlag = 0;

 }
}
#line 80 "C:/Users/Val/Desktop/MikroE/Example4/Timers.c"
struct timers TimerPool[ 10 ];
#line 89 "C:/Users/Val/Desktop/MikroE/Example4/Timers.c"
void init_timerpool(void) {
 unsigned short int i;

 for (i=0; i <  10 ; i++) {
 TimerPool[i].TimerField = 0;
 TimerPool[i].Free =  1 ;
 }
}
#line 104 "C:/Users/Val/Desktop/MikroE/Example4/Timers.c"
unsigned short int get_timer(void) {
 unsigned short int i;

 for (i=0; i <  10 ; i++) {
 if (TimerPool[i].Free ==  1 ) {
 TimerPool[i].Free =  0 ;
 return i;
 }
 }


 USB_PutQueue("TIMERS: No Timers, Resetting..\r\n");

 SystemReset();
 return (0);
}
#line 127 "C:/Users/Val/Desktop/MikroE/Example4/Timers.c"
void free_timer(unsigned short int nbr) {
 if (nbr > ( 10 -1))
 return;

 TimerPool[nbr].Free =  1 ;
}
#line 141 "C:/Users/Val/Desktop/MikroE/Example4/Timers.c"
void set_timer(unsigned short int nbr, unsigned long int tout) {
 if (nbr > ( 10 -1))
 return;

 if (TimerPool[nbr].Free ==  1 )
 return;

 TimerPool[nbr].TimerField = tout;
}
#line 157 "C:/Users/Val/Desktop/MikroE/Example4/Timers.c"
unsigned long int check_timer(unsigned short int nbr) {
 return TimerPool[nbr].TimerField;
}
#line 167 "C:/Users/Val/Desktop/MikroE/Example4/Timers.c"
void irqhandler_timer(void) {
 unsigned short int i;

 for (i=0; i< 10 ; i++) {
 if (TimerPool[i].Free ==  0  && TimerPool[i].TimerField != 0)
 TimerPool[i].TimerField--;
 }
}
#line 190 "C:/Users/Val/Desktop/MikroE/Example4/Timers.c"
void Timer6Interrupt() iv IVT_INT_TIM6_DAC ics ICS_AUTO {
 UIF_TIM6_SR_bit = 0;



 DoSine();

}
#line 201 "C:/Users/Val/Desktop/MikroE/Example4/Timers.c"
void Timer6_Initialize(void) {
 TIM6EN_bit = 1;
#line 223 "C:/Users/Val/Desktop/MikroE/Example4/Timers.c"
 TIM6_PSC = 99;
 TIM6_ARR = 10;

 TIM6_CR2bits.MMS = 0x2;
 CEN_TIM6_CR1_bit = 1;
 UIE_TIM6_DIER_bit = 1;
 NVIC_IntEnable(IVT_INT_TIM6_DAC);
}
#line 234 "C:/Users/Val/Desktop/MikroE/Example4/Timers.c"
void Timer7Interrupt() iv IVT_INT_TIM7 ics ICS_AUTO {
 UIF_TIM7_SR_bit = 0;
 USB_PutQueue("Timer 7 interrupt\r\n");
}
#line 241 "C:/Users/Val/Desktop/MikroE/Example4/Timers.c"
void Timer7_Initialize(void) {
 TIM7EN_bit = 1;
 TIM7_PSC = 5999;
 TIM7_ARR = 10000;
 TIM7_CR2bits.MMS = 0x2;
 CEN_TIM7_CR1_bit = 1;
 UIE_TIM7_DIER_bit = 1;
 NVIC_IntEnable(IVT_INT_TIM7);
}
