#line 1 "C:/Users/Val/Desktop/MikroE/Example4/USB_Driver.c"
#line 1 "c:/users/val/desktop/mikroe/example4/usb_driver.h"
#line 11 "c:/users/val/desktop/mikroe/example4/usb_driver.h"
typedef char *pnt;


typedef struct USB_TxStruct {
 unsigned int in;
 unsigned int out;
 pnt q[ 32 ];
}USB_TxStruct;



void USB_Init(void);
void USB_TxQueueInit(void);
void USB_PutQueue(char *msg);
void USB_CheckOut(void);
void USB_CheckIn(void);
#line 1 "c:/users/val/desktop/mikroe/example4/buffers.h"
#line 13 "c:/users/val/desktop/mikroe/example4/buffers.h"
char* GetBuffer(void);
#line 1 "c:/users/val/desktop/mikroe/example4/led.h"
#line 13 "c:/users/val/desktop/mikroe/example4/led.h"
void LED_Initialize(void);

void LED_Set_Yellow(void);
void LED_Clr_Yellow(void);
void LED_Set_Red(void);
void LED_Clr_Red(void);
#line 1 "c:/users/val/desktop/mikroe/example4/rtc.h"
#line 13 "c:/users/val/desktop/mikroe/example4/rtc.h"
typedef struct Time {
 unsigned int year;
 unsigned short weekday;
 unsigned short month;
 unsigned short day;
 unsigned short hours;
 unsigned short minutes;
 unsigned short seconds;
 unsigned short ampm;
} TTime;




void RTC_Initialize(void);
void RTC_Write(TTime *RTCC_Time);
void RTC_Read(TTime *RTCC_Time);

void RTC_WriteSRAM(unsigned short Reg, unsigned long Value);
unsigned long RTC_ReadSRAM(unsigned short Reg);

void RTC_WriteCCR(char Cal);
void RTC_ReadCCR(void);
void RTC_ReadISR(void);
#line 1 "c:/users/val/desktop/mikroe/example4/adc_dac.h"
#line 19 "c:/users/val/desktop/mikroe/example4/adc_dac.h"
void EnableDAC1(void);
void EnableDAC2(void);
void EnableDACs(void);
void SetDAC1(unsigned long Data);
void SetDAC2(unsigned long Data);
void SetDACs(unsigned long Data1, unsigned long Data2);
void SetDAC_Ch1(unsigned long Data);


void DAC1_Initialize(void);
void DAC1_Set(unsigned Value);
void DAC2_Initialize(void);
void DAC2_Set(unsigned Value);
void DoSine(void);



void DispDAC_CR(void);

void DispDAC_DHR12R1(void);
void DispDAC_DOR1(void);

void DispDAC_DHR12R2(void);
void DispDAC_DOR2(void);
#line 1 "c:/users/val/desktop/mikroe/example4/timers.h"
#line 9 "c:/users/val/desktop/mikroe/example4/timers.h"
void TimerInit();
void TimerCheck();
#line 31 "c:/users/val/desktop/mikroe/example4/timers.h"
struct timers {
 unsigned long int TimerField;
 unsigned short int Free;
};
#line 43 "c:/users/val/desktop/mikroe/example4/timers.h"
void init_timerpool(void);
#line 52 "c:/users/val/desktop/mikroe/example4/timers.h"
unsigned short int get_timer(void);
#line 61 "c:/users/val/desktop/mikroe/example4/timers.h"
void free_timer(unsigned short int nbr);
#line 71 "c:/users/val/desktop/mikroe/example4/timers.h"
void set_timer(unsigned short int nbr, unsigned long int tout);
#line 80 "c:/users/val/desktop/mikroe/example4/timers.h"
unsigned long int check_timer(unsigned short int nbr);
#line 89 "c:/users/val/desktop/mikroe/example4/timers.h"
void irqhandler_timer(void);





void Timer6_Initialize(void);
void Timer7_Initialize(void);
#line 16 "C:/Users/Val/Desktop/MikroE/Example4/USB_Driver.c"
char readbuff[64];
char writebuff[64];

USB_TxStruct USB_Queue;

extern TTime MyTime;
extern unsigned short int Amp;
#line 29 "C:/Users/Val/Desktop/MikroE/Example4/USB_Driver.c"
void USBInterrupt() iv IVT_INT_OTG_FS ics ICS_AUTO {
 USB_Interrupt_Proc();
}
#line 35 "C:/Users/Val/Desktop/MikroE/Example4/USB_Driver.c"
void USB_Init(void) {



 HID_Enable(&readbuff,&writebuff);
 USB_TxQueueInit();

}
#line 46 "C:/Users/Val/Desktop/MikroE/Example4/USB_Driver.c"
void USB_TxQueueInit(void) {

 USB_Queue.in = 0;
 USB_Queue.out = 0;
}
#line 55 "C:/Users/Val/Desktop/MikroE/Example4/USB_Driver.c"
void USB_PutQueue(char *msg) {

 USB_Queue.q[USB_Queue.in++] = msg;
 if (USB_Queue.in > ( 32 -1))
 USB_Queue.in = 0;
}
#line 68 "C:/Users/Val/Desktop/MikroE/Example4/USB_Driver.c"
void USB_CheckOut(void) {

 if (USB_Queue.in != USB_Queue.out) {


 if (HID_Write(USB_Queue.q[USB_Queue.out],64) != 0) {
 USB_Queue.out++;
 if (USB_Queue.out > ( 32 -1))
 USB_Queue.out = 0;
 }
 }
}
#line 85 "C:/Users/Val/Desktop/MikroE/Example4/USB_Driver.c"
void USB_CheckIn(void) {
 char *BufNum;
 unsigned int Work;
 unsigned long BkpReg;

 if (HID_Read() != 0) {
 switch (readbuff[0]) {

 case 'a':
 USB_PutQueue("Command a received\r\n");
 break;
 case 'b':
 LED_Set_Yellow();
 USB_PutQueue("Yellow set\r\n");
 break;
 case 'c':
 LED_Clr_Yellow();
 USB_PutQueue("Yellow cleared\r\n");
 break;
 case 'd':
 LED_Set_Red();
 USB_PutQueue("Red set\r\n");
 break;
 case 'e':
 LED_Clr_Red();
 USB_PutQueue("Red cleared\r\n");
 break;
 case 'f':




 Work = readbuff[2] & 0x0F;
 Work <<= 4;
 Work |= readbuff[3] & 0x0F;
 MyTime.year = Bcd2Dec16(Work);

 Work = readbuff[5] & 0x0F;
 MyTime.weekday = Work;

 Work = readbuff[7] & 0x0F;
 Work <<= 4;
 Work |= readbuff[8] & 0x0F;
 MyTime.month = Bcd2Dec(Work);

 Work = readbuff[10] & 0x0F;
 Work <<= 4;
 Work |= readbuff[11] & 0x0F;
 MyTime.day = Bcd2Dec(Work);

 Work = readbuff[13] & 0x0F;
 Work <<= 4;
 Work |= readbuff[14] & 0x0F;
 MyTime.hours = Bcd2Dec(Work);

 Work = readbuff[16] & 0x0F;
 Work <<= 4;
 Work |= readbuff[17] & 0x0F;
 MyTime.minutes = Bcd2Dec(Work);

 Work = readbuff[19] & 0x0F;
 Work <<= 4;
 Work |= readbuff[20] & 0x0F;
 MyTime.seconds = Bcd2Dec(Work);

 BufNum = GetBuffer();
 sprintf(BufNum,"%04d/%02d/%02d %02d:%02d:%02d %d\r\n",MyTime.year,MyTime.month,MyTime.day,MyTime.hours,MyTime.minutes,MyTime.seconds,MyTime.weekday);
 USB_PutQueue(BufNum);

 RTC_Write(&MyTime);
 break;
 case 'g':
 RTC_Read(&MyTime);
 break;
 case 'h':
 RTC_WriteSRAM(0,0xAAAA5555);
 RTC_WriteSRAM(1,0x5555AAAA);

 BkpReg = RTC_ReadSRAM(0);
 BufNum = GetBuffer();
 sprintf(BufNum,"Addr0: %08LX\r\n",BkpReg);
 USB_PutQueue(BufNum);

 BkpReg = RTC_ReadSRAM(1);
 BufNum = GetBuffer();
 sprintf(BufNum,"Addr1: %08LX\r\n",BkpReg);
 USB_PutQueue(BufNum);
 break;
 case 'i':
 RTC_ReadISR();
 break;
 case 'j':
 DAC1_Initialize();
 Timer6_Initialize();
 break;
 case 'k':
 if (Amp < 255)
 Amp++;
 BufNum = GetBuffer();
 sprintf(BufNum,"Amp: %02X\r\n",Amp);
 USB_PutQueue(BufNum);
 break;
 case 'l':
 if (Amp > 0)
 Amp--;
 BufNum = GetBuffer();
 sprintf(BufNum,"Amp: %02X\r\n",Amp);
 USB_PutQueue(BufNum);
 break;
 case 'm':
 break;
 case 'n':
 break;
 case 'o':
 break;
 case 'p':
 break;
 case 'q':
 break;
 case 'r':
 break;
 case 's':
 break;
 case 't':
 break;
 case 'u':
 break;
 case 'v':
 break;
 case 'w':
 break;
 case 'x':
 break;
 case 'y':
 break;
 case 'z':
 break;



 default:
 USB_PutQueue("Unknown command: ");

 BufNum = GetBuffer();
 (void)sprintf(BufNum,"%c\r\n",readbuff[0]);
 USB_PutQueue(BufNum);
 break;
 }
 }
}
